/* DBusInterfaces.c generated by valac 0.38.10, the Vala compiler
 * generated from DBusInterfaces.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Power and system control */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>


#define TYPE_SYSTEM_INTERFACE (system_interface_get_type ())
#define SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_INTERFACE, SystemInterface))
#define IS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_INTERFACE))
#define SYSTEM_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SYSTEM_INTERFACE, SystemInterfaceIface))

typedef struct _SystemInterface SystemInterface;
typedef struct _SystemInterfaceIface SystemInterfaceIface;

#define TYPE_SYSTEM_INTERFACE_PROXY (system_interface_proxy_get_type ())
typedef GDBusProxy SystemInterfaceProxy;
typedef GDBusProxyClass SystemInterfaceProxyClass;

struct _SystemInterfaceIface {
	GTypeInterface parent_iface;
	void (*reboot) (SystemInterface* self, gboolean interactive, GError** error);
};



GType system_interface_proxy_get_type (void) G_GNUC_CONST;
guint system_interface_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType system_interface_get_type (void) G_GNUC_CONST;
void system_interface_reboot (SystemInterface* self, gboolean interactive, GError** error);
static void system_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void system_interface_proxy_reboot (SystemInterface* self, gboolean interactive, GError** error);
static void system_interface_proxy_system_interface_interface_init (SystemInterfaceIface* iface);
static void _dbus_system_interface_reboot (SystemInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void system_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* system_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean system_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _system_interface_unregister_object (gpointer user_data);

static const GDBusArgInfo _system_interface_dbus_arg_info_reboot_interactive = {-1, "interactive", "b"};
static const GDBusArgInfo * const _system_interface_dbus_arg_info_reboot_in[] = {&_system_interface_dbus_arg_info_reboot_interactive, NULL};
static const GDBusArgInfo * const _system_interface_dbus_arg_info_reboot_out[] = {NULL};
static const GDBusMethodInfo _system_interface_dbus_method_info_reboot = {-1, "Reboot", (GDBusArgInfo **) (&_system_interface_dbus_arg_info_reboot_in), (GDBusArgInfo **) (&_system_interface_dbus_arg_info_reboot_out)};
static const GDBusMethodInfo * const _system_interface_dbus_method_info[] = {&_system_interface_dbus_method_info_reboot, NULL};
static const GDBusSignalInfo * const _system_interface_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _system_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _system_interface_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_system_interface_dbus_method_info), (GDBusSignalInfo **) (&_system_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_system_interface_dbus_property_info)};
static const GDBusInterfaceVTable _system_interface_dbus_interface_vtable = {system_interface_dbus_interface_method_call, system_interface_dbus_interface_get_property, system_interface_dbus_interface_set_property};

void system_interface_reboot (SystemInterface* self, gboolean interactive, GError** error) {
	g_return_if_fail (self != NULL);
	SYSTEM_INTERFACE_GET_INTERFACE (self)->reboot (self, interactive, error);
}


static void system_interface_base_init (SystemInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType system_interface_get_type (void) {
	static volatile gsize system_interface_type_id__volatile = 0;
	if (g_once_init_enter (&system_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SystemInterfaceIface), (GBaseInitFunc) system_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType system_interface_type_id;
		system_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SystemInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (system_interface_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (system_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) system_interface_proxy_get_type);
		g_type_set_qdata (system_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
		g_type_set_qdata (system_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_system_interface_dbus_interface_info));
		g_type_set_qdata (system_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) system_interface_register_object);
		g_once_init_leave (&system_interface_type_id__volatile, system_interface_type_id);
	}
	return system_interface_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (SystemInterfaceProxy, system_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SYSTEM_INTERFACE, system_interface_proxy_system_interface_interface_init) )
static void system_interface_proxy_class_init (SystemInterfaceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = system_interface_proxy_g_signal;
}


static void system_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void system_interface_proxy_init (SystemInterfaceProxy* self) {
}


static void system_interface_proxy_reboot (SystemInterface* self, gboolean interactive, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "Reboot");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (interactive));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void system_interface_proxy_system_interface_interface_init (SystemInterfaceIface* iface) {
	iface->reboot = system_interface_proxy_reboot;
}


static void _dbus_system_interface_reboot (SystemInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean interactive = FALSE;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	interactive = g_variant_get_boolean (_tmp8_);
	g_variant_unref (_tmp8_);
	system_interface_reboot (self, interactive, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void system_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Reboot") == 0) {
		_dbus_system_interface_reboot (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* system_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean system_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint system_interface_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_system_interface_dbus_interface_info), &_system_interface_dbus_interface_vtable, data, _system_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _system_interface_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}



