/* SharePopover.c generated by valac 0.38.10, the Vala compiler
 * generated from SharePopover.vala, do not modify */

/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Daniel Foré <daniel@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>


#define TYPE_SHARE_POPOVER (share_popover_get_type ())
#define SHARE_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHARE_POPOVER, SharePopover))
#define SHARE_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHARE_POPOVER, SharePopoverClass))
#define IS_SHARE_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHARE_POPOVER))
#define IS_SHARE_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHARE_POPOVER))
#define SHARE_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHARE_POPOVER, SharePopoverClass))

typedef struct _SharePopover SharePopover;
typedef struct _SharePopoverClass SharePopoverClass;
typedef struct _SharePopoverPrivate SharePopoverPrivate;
enum  {
	SHARE_POPOVER_0_PROPERTY,
	SHARE_POPOVER_BODY_PROPERTY,
	SHARE_POPOVER_URI_PROPERTY,
	SHARE_POPOVER_NUM_PROPERTIES
};
static GParamSpec* share_popover_properties[SHARE_POPOVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SHARE_POPOVER_LINK_COPIED_SIGNAL,
	SHARE_POPOVER_NUM_SIGNALS
};
static guint share_popover_signals[SHARE_POPOVER_NUM_SIGNALS] = {0};

struct _SharePopover {
	GtkPopover parent_instance;
	SharePopoverPrivate * priv;
};

struct _SharePopoverClass {
	GtkPopoverClass parent_class;
};

struct _SharePopoverPrivate {
	gchar* _body;
	gchar* _uri;
};


static gpointer share_popover_parent_class = NULL;

GType share_popover_get_type (void) G_GNUC_CONST;
#define SHARE_POPOVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SHARE_POPOVER, SharePopoverPrivate))
SharePopover* share_popover_new (const gchar* body, const gchar* uri);
SharePopover* share_popover_construct (GType object_type, const gchar* body, const gchar* uri);
const gchar* share_popover_get_body (SharePopover* self);
void share_popover_set_body (SharePopover* self, const gchar* value);
const gchar* share_popover_get_uri (SharePopover* self);
void share_popover_set_uri (SharePopover* self, const gchar* value);
static GObject * share_popover_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _share_popover___lambda111_ (SharePopover* self);
static void __share_popover___lambda111__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda112_ (SharePopover* self);
static void __share_popover___lambda112__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda113_ (SharePopover* self);
static void __share_popover___lambda113__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda114_ (SharePopover* self);
static void __share_popover___lambda114__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda115_ (SharePopover* self);
static void __share_popover___lambda115__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda116_ (SharePopover* self);
static void __share_popover___lambda116__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda117_ (SharePopover* self);
static void __share_popover___lambda117__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _share_popover___lambda118_ (SharePopover* self);
static void __share_popover___lambda118__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void share_popover_finalize (GObject * obj);
static void _vala_share_popover_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_share_popover_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


SharePopover* share_popover_construct (GType object_type, const gchar* body, const gchar* uri) {
	SharePopover * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (body != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = body;
	_tmp1_ = uri;
	self = (SharePopover*) g_object_new (object_type, "body", _tmp0_, "uri", _tmp1_, NULL);
	return self;
}


SharePopover* share_popover_new (const gchar* body, const gchar* uri) {
	return share_popover_construct (TYPE_SHARE_POPOVER, body, uri);
}


const gchar* share_popover_get_body (SharePopover* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_body;
	result = _tmp0_;
	return result;
}


void share_popover_set_body (SharePopover* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, share_popover_get_body (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_body);
		self->priv->_body = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, share_popover_properties[SHARE_POPOVER_BODY_PROPERTY]);
	}
}


const gchar* share_popover_get_uri (SharePopover* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}


void share_popover_set_uri (SharePopover* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, share_popover_get_uri (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_uri);
		self->priv->_uri = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, share_popover_properties[SHARE_POPOVER_URI_PROPERTY]);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _share_popover___lambda111_ (SharePopover* self) {
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	const gchar* _tmp4_;
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	clipboard = _tmp2_;
	_tmp3_ = clipboard;
	_tmp4_ = self->priv->_uri;
	gtk_clipboard_set_text (_tmp3_, _tmp4_, -1);
	g_signal_emit (self, share_popover_signals[SHARE_POPOVER_LINK_COPIED_SIGNAL], 0);
	gtk_widget_hide ((GtkWidget*) self);
	_g_object_unref0 (clipboard);
}


static void __share_popover___lambda111__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda111_ ((SharePopover*) self);
}


static void _share_popover___lambda112_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = self->priv->_body;
		_tmp1_ = self->priv->_uri;
		_tmp2_ = g_strdup_printf ("mailto:?body=%s %s", _tmp0_, _tmp1_);
		_tmp3_ = _tmp2_;
		g_app_info_launch_default_for_uri (_tmp3_, NULL, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch51_g_error;
		}
	}
	goto __finally51;
	__catch51_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("SharePopover.vala:106: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally51:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda112__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda112_ ((SharePopover*) self);
}


static void _share_popover___lambda113_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->_uri;
		_tmp1_ = g_strdup_printf ("https://www.facebook.com/sharer/sharer.php?u=%s", _tmp0_);
		_tmp2_ = _tmp1_;
		g_app_info_launch_default_for_uri (_tmp2_, NULL, &_inner_error_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch52_g_error;
		}
	}
	goto __finally52;
	__catch52_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("SharePopover.vala:115: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally52:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda113__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda113_ ((SharePopover*) self);
}


static void _share_popover___lambda114_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->_uri;
		_tmp1_ = g_strdup_printf ("https://plus.google.com/share?url=%s", _tmp0_);
		_tmp2_ = _tmp1_;
		g_app_info_launch_default_for_uri (_tmp2_, NULL, &_inner_error_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch53_g_error;
		}
	}
	goto __finally53;
	__catch53_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("SharePopover.vala:124: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally53:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda114__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda114_ ((SharePopover*) self);
}


static void _share_popover___lambda115_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = self->priv->_body;
		_tmp1_ = self->priv->_uri;
		_tmp2_ = g_strdup_printf ("http://twitter.com/home/?status=%s %s", _tmp0_, _tmp1_);
		_tmp3_ = _tmp2_;
		g_app_info_launch_default_for_uri (_tmp3_, NULL, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch54_g_error;
		}
	}
	goto __finally54;
	__catch54_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("SharePopover.vala:133: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally54:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda115__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda115_ ((SharePopover*) self);
}


static void _share_popover___lambda116_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = self->priv->_body;
		_tmp1_ = self->priv->_uri;
		_tmp2_ = g_strdup_printf ("http://www.reddit.com/submit?title=%s&url=%s", _tmp0_, _tmp1_);
		_tmp3_ = _tmp2_;
		g_app_info_launch_default_for_uri (_tmp3_, NULL, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch55_g_error;
		}
	}
	goto __finally55;
	__catch55_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("SharePopover.vala:142: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally55:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda116__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda116_ ((SharePopover*) self);
}


static void _share_popover___lambda117_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->_uri;
		_tmp1_ = g_strdup_printf ("https://www.tumblr.com/share/link?url=%s", _tmp0_);
		_tmp2_ = _tmp1_;
		g_app_info_launch_default_for_uri (_tmp2_, NULL, &_inner_error_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch56_g_error;
		}
	}
	goto __finally56;
	__catch56_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("SharePopover.vala:151: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally56:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda117__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda117_ ((SharePopover*) self);
}


static void _share_popover___lambda118_ (SharePopover* self) {
	GError * _inner_error_ = NULL;
	{
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->_uri;
		_tmp1_ = g_strdup_printf ("https://t.me/share/url?url=%s", _tmp0_);
		_tmp2_ = _tmp1_;
		g_app_info_launch_default_for_uri (_tmp2_, NULL, &_inner_error_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch57_g_error;
		}
	}
	goto __finally57;
	__catch57_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("SharePopover.vala:160: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally57:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void __share_popover___lambda118__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_share_popover___lambda118_ ((SharePopover*) self);
}


static GObject * share_popover_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SharePopover * self;
	GtkButton* email_button = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* facebook_button = NULL;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* google_button = NULL;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkButton* twitter_button = NULL;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* reddit_button = NULL;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkButton* tumblr_button = NULL;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkButton* telegram_button = NULL;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkButton* copy_link_button = NULL;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp32_;
	GtkSizeGroup* _tmp33_;
	GtkButton* _tmp34_;
	GtkSizeGroup* _tmp35_;
	GtkButton* _tmp36_;
	GtkGrid* service_grid = NULL;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkButton* _tmp40_;
	GtkGrid* _tmp41_;
	GtkButton* _tmp42_;
	GtkGrid* _tmp43_;
	GtkButton* _tmp44_;
	GtkGrid* _tmp45_;
	GtkButton* _tmp46_;
	GtkGrid* _tmp47_;
	GtkButton* _tmp48_;
	GtkGrid* _tmp49_;
	GtkButton* _tmp50_;
	GtkGrid* _tmp51_;
	GtkButton* _tmp52_;
	GtkGrid* system_grid = NULL;
	GtkGrid* _tmp53_;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkButton* _tmp56_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkSeparator* _tmp62_;
	GtkSeparator* _tmp63_;
	GtkGrid* _tmp64_;
	GtkGrid* _tmp65_;
	GtkGrid* _tmp66_;
	GtkGrid* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkButton* _tmp71_;
	GtkButton* _tmp72_;
	GtkButton* _tmp73_;
	GtkButton* _tmp74_;
	GtkButton* _tmp75_;
	parent_class = G_OBJECT_CLASS (share_popover_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHARE_POPOVER, SharePopover);
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name ("internet-mail", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp0_);
	email_button = _tmp0_;
	_tmp1_ = email_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _ ("Email"));
	_tmp2_ = email_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_FLAT);
	_tmp4_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-facebook", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp4_);
	facebook_button = _tmp4_;
	_tmp5_ = facebook_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _ ("Facebook"));
	_tmp6_ = facebook_button;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, GTK_STYLE_CLASS_FLAT);
	_tmp8_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-google-plus", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp8_);
	google_button = _tmp8_;
	_tmp9_ = google_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _ ("Google+"));
	_tmp10_ = google_button;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, GTK_STYLE_CLASS_FLAT);
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-twitter", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp12_);
	twitter_button = _tmp12_;
	_tmp13_ = twitter_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Twitter"));
	_tmp14_ = twitter_button;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, GTK_STYLE_CLASS_FLAT);
	_tmp16_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-reddit", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp16_);
	reddit_button = _tmp16_;
	_tmp17_ = reddit_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp17_, _ ("Reddit"));
	_tmp18_ = reddit_button;
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
	gtk_style_context_add_class (_tmp19_, GTK_STYLE_CLASS_FLAT);
	_tmp20_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-tumblr", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp20_);
	tumblr_button = _tmp20_;
	_tmp21_ = tumblr_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp21_, _ ("Tumblr"));
	_tmp22_ = tumblr_button;
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_FLAT);
	_tmp24_ = (GtkButton*) gtk_button_new_from_icon_name ("online-account-telegram", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp24_);
	telegram_button = _tmp24_;
	_tmp25_ = telegram_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, _ ("Telegram"));
	_tmp26_ = telegram_button;
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
	gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_FLAT);
	_tmp28_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-copy-symbolic", GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp28_);
	copy_link_button = _tmp28_;
	_tmp29_ = copy_link_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _ ("Copy link"));
	_tmp30_ = copy_link_button;
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
	gtk_style_context_add_class (_tmp31_, GTK_STYLE_CLASS_FLAT);
	_tmp32_ = gtk_size_group_new (GTK_SIZE_GROUP_BOTH);
	size_group = _tmp32_;
	_tmp33_ = size_group;
	_tmp34_ = email_button;
	gtk_size_group_add_widget (_tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = size_group;
	_tmp36_ = copy_link_button;
	gtk_size_group_add_widget (_tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp37_);
	service_grid = _tmp37_;
	_tmp38_ = service_grid;
	g_object_set ((GtkWidget*) _tmp38_, "margin", 6, NULL);
	_tmp39_ = service_grid;
	_tmp40_ = email_button;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = service_grid;
	_tmp42_ = facebook_button;
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
	_tmp43_ = service_grid;
	_tmp44_ = google_button;
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = service_grid;
	_tmp46_ = twitter_button;
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
	_tmp47_ = service_grid;
	_tmp48_ = reddit_button;
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = service_grid;
	_tmp50_ = tumblr_button;
	gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = service_grid;
	_tmp52_ = telegram_button;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp53_);
	system_grid = _tmp53_;
	_tmp54_ = system_grid;
	g_object_set ((GtkWidget*) _tmp54_, "margin", 6, NULL);
	_tmp55_ = system_grid;
	_tmp56_ = copy_link_button;
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp57_);
	grid = _tmp57_;
	_tmp58_ = grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp58_, GTK_ORIENTATION_VERTICAL);
	_tmp59_ = grid;
	_tmp60_ = service_grid;
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
	_tmp61_ = grid;
	_tmp62_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp62_);
	_tmp63_ = _tmp62_;
	gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp63_);
	_g_object_unref0 (_tmp63_);
	_tmp64_ = grid;
	_tmp65_ = system_grid;
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
	_tmp66_ = grid;
	gtk_widget_show_all ((GtkWidget*) _tmp66_);
	_tmp67_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp67_);
	_tmp68_ = copy_link_button;
	g_signal_connect_object (_tmp68_, "clicked", (GCallback) __share_popover___lambda111__gtk_button_clicked, self, 0);
	_tmp69_ = email_button;
	g_signal_connect_object (_tmp69_, "clicked", (GCallback) __share_popover___lambda112__gtk_button_clicked, self, 0);
	_tmp70_ = facebook_button;
	g_signal_connect_object (_tmp70_, "clicked", (GCallback) __share_popover___lambda113__gtk_button_clicked, self, 0);
	_tmp71_ = google_button;
	g_signal_connect_object (_tmp71_, "clicked", (GCallback) __share_popover___lambda114__gtk_button_clicked, self, 0);
	_tmp72_ = twitter_button;
	g_signal_connect_object (_tmp72_, "clicked", (GCallback) __share_popover___lambda115__gtk_button_clicked, self, 0);
	_tmp73_ = reddit_button;
	g_signal_connect_object (_tmp73_, "clicked", (GCallback) __share_popover___lambda116__gtk_button_clicked, self, 0);
	_tmp74_ = tumblr_button;
	g_signal_connect_object (_tmp74_, "clicked", (GCallback) __share_popover___lambda117__gtk_button_clicked, self, 0);
	_tmp75_ = telegram_button;
	g_signal_connect_object (_tmp75_, "clicked", (GCallback) __share_popover___lambda118__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (system_grid);
	_g_object_unref0 (service_grid);
	_g_object_unref0 (size_group);
	_g_object_unref0 (copy_link_button);
	_g_object_unref0 (telegram_button);
	_g_object_unref0 (tumblr_button);
	_g_object_unref0 (reddit_button);
	_g_object_unref0 (twitter_button);
	_g_object_unref0 (google_button);
	_g_object_unref0 (facebook_button);
	_g_object_unref0 (email_button);
	return obj;
}


static void share_popover_class_init (SharePopoverClass * klass) {
	share_popover_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SharePopoverPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_share_popover_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_share_popover_set_property;
	G_OBJECT_CLASS (klass)->constructor = share_popover_constructor;
	G_OBJECT_CLASS (klass)->finalize = share_popover_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARE_POPOVER_BODY_PROPERTY, share_popover_properties[SHARE_POPOVER_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SHARE_POPOVER_URI_PROPERTY, share_popover_properties[SHARE_POPOVER_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	share_popover_signals[SHARE_POPOVER_LINK_COPIED_SIGNAL] = g_signal_new ("link-copied", TYPE_SHARE_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void share_popover_instance_init (SharePopover * self) {
	self->priv = SHARE_POPOVER_GET_PRIVATE (self);
}


static void share_popover_finalize (GObject * obj) {
	SharePopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHARE_POPOVER, SharePopover);
	_g_free0 (self->priv->_body);
	_g_free0 (self->priv->_uri);
	G_OBJECT_CLASS (share_popover_parent_class)->finalize (obj);
}


GType share_popover_get_type (void) {
	static volatile gsize share_popover_type_id__volatile = 0;
	if (g_once_init_enter (&share_popover_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SharePopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) share_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SharePopover), 0, (GInstanceInitFunc) share_popover_instance_init, NULL };
		GType share_popover_type_id;
		share_popover_type_id = g_type_register_static (gtk_popover_get_type (), "SharePopover", &g_define_type_info, 0);
		g_once_init_leave (&share_popover_type_id__volatile, share_popover_type_id);
	}
	return share_popover_type_id__volatile;
}


static void _vala_share_popover_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SharePopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SHARE_POPOVER, SharePopover);
	switch (property_id) {
		case SHARE_POPOVER_BODY_PROPERTY:
		g_value_set_string (value, share_popover_get_body (self));
		break;
		case SHARE_POPOVER_URI_PROPERTY:
		g_value_set_string (value, share_popover_get_uri (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_share_popover_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SharePopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SHARE_POPOVER, SharePopover);
	switch (property_id) {
		case SHARE_POPOVER_BODY_PROPERTY:
		share_popover_set_body (self, g_value_get_string (value));
		break;
		case SHARE_POPOVER_URI_PROPERTY:
		share_popover_set_uri (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



